## netdata-1.45.4.tar.gz

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.13.0)

#
# version atrocities
#

find_package(Git)

if(GIT_EXECUTABLE)
        execute_process(COMMAND ${GIT_EXECUTABLE} describe
                        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                        RESULT_VARIABLE GIT_DESCRIBE_RESULT
                        OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT)
        if(GIT_DESCRIBE_RESULT)
                file(STRINGS packaging/version GIT_DESCRIBE_OUTPUT)
                message(WARNING "using version from packaging/version: '${GIT_DESCRIBE_OUTPUT}'")
        endif()
else()
        file(STRINGS packaging/version GIT_DESCRIBE_OUTPUT)
        message(WARNING "using version from packaging/version: '${GIT_DESCRIBE_OUTPUT}'")
endif()

string(STRIP ${GIT_DESCRIBE_OUTPUT} GIT_DESCRIBE_OUTPUT)
string(REGEX MATCH "v?([0-9]+)\\.([0-9]+)\\.([0-9]+)-?([0-9]+)?-?([0-9a-zA-Z]+)?" MATCHES "${GIT_DESCRIBE_OUTPUT}")

if(CMAKE_MATCH_COUNT EQUAL 3)
        set(FIELD_MAJOR ${CMAKE_MATCH_1})
        set(FIELD_MINOR ${CMAKE_MATCH_2})
        set(FIELD_PATCH ${CMAKE_MATCH_3})
        set(FIELD_TWEAK 0)
        set(FIELD_DESCR "N/A")
elseif(CMAKE_MATCH_COUNT EQUAL 4)
        set(FIELD_MAJOR ${CMAKE_MATCH_1})
        set(FIELD_MINOR ${CMAKE_MATCH_2})
        set(FIELD_PATCH ${CMAKE_MATCH_3})
        set(FIELD_TWEAK ${CMAKE_MATCH_4})
        set(FIELD_DESCR "N/A")
elseif(CMAKE_MATCH_COUNT EQUAL 5)
        set(FIELD_MAJOR ${CMAKE_MATCH_1})
        set(FIELD_MINOR ${CMAKE_MATCH_2})
        set(FIELD_PATCH ${CMAKE_MATCH_3})
        set(FIELD_TWEAK ${CMAKE_MATCH_4})
        set(FIELD_DESCR ${CMAKE_MATCH_5})
else()
        message(FATAL_ERROR "Wrong version regex match count ${CMAKE_MATCH_COUNT} (should be in 3, 4 or 5)")
endif()

set(NETDATA_VERSION ${FIELD_MAJOR}.${FIELD_MINOR}.${FIELD_PATCH}.${FIELD_TWEAK})

#
# project
#

project(netdata
        VERSION ${NETDATA_VERSION}
        DESCRIPTION "Netdata real-time monitoring"
        HOMEPAGE_URL "https://www.netdata.cloud"
        LANGUAGES C CXX)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/packaging/cmake/Modules")

find_package(PkgConfig REQUIRED)

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 14)

option(USE_CXX_11 "use C++11 instead of C++14" False)

if(USE_CXX_11)
    set(CMAKE_CXX_STANDARD 11)
endif()

set(CMAKE_C_STANDARD_REQUIRED On)
set(CMAKE_CXX_STANDARD_REQUIRED On)

set(SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})

if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release")
endif()

option(ENABLE_ADDRESS_SANITIZER "enable address sanitizer" False)

if(ENABLE_ADDRESS_SANITIZER)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fexceptions")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS}")

set(CMAKE_EXPORT_COMPILE_COMMANDS On)

set(CONFIG_H_DIR ${CMAKE_BINARY_DIR})
set(CONFIG_H ${CONFIG_H_DIR}/config.h)

option(ENABLE_CLOUD "enable cloud" True)
option(ENABLE_ACLK "enable aclk" True)
option(ENABLE_ML "enable machine learning" True)
option(ENABLE_H2O "enable h2o" True)
option(ENABLE_DBENGINE "enable dbengine" True)

option(ENABLE_PLUGIN_APPS "enable apps.plugin" True)
option(ENABLE_PLUGIN_CGROUP_NETWORK "enable cgroup-network plugin" True)
option(ENABLE_PLUGIN_CUPS "enable cups.plugin" True)
option(ENABLE_PLUGIN_DEBUGFS "enable debugfs.plugin" True)
option(ENABLE_PLUGIN_EBPF "enable ebpf.plugin" True)
option(ENABLE_PLUGIN_FREEIPMI "enable freeipmi.plugin" True)
option(ENABLE_PLUGIN_GO "enable go.d.plugin" True)
option(ENABLE_PLUGIN_LOCAL_LISTENERS "enable local-listeners" True)
option(ENABLE_PLUGIN_LOGS_MANAGEMENT "enable logs-management.plugin" True)
option(ENABLE_PLUGIN_NETWORK_VIEWER "enable network-viewer" True)
option(ENABLE_PLUGIN_NFACCT "enable nfacct.plugin" True)
option(ENABLE_PLUGIN_PERF "enable perf.plugin" True)
option(ENABLE_PLUGIN_SLABINFO "enable slabinfo.plugin" True)
option(ENABLE_PLUGIN_SYSTEMD_JOURNAL "enable systemd-journal.plugin" True)
option(ENABLE_PLUGIN_XENSTAT "enable xenstat.plugin" True)

option(ENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE "enable prometheus remote write exporter" True)
option(ENABLE_EXPORTER_MONGODB "enable mongodb exporter" True)

option(ENABLE_BUNDLED_JSONC "enable bundled json-c" False)
option(ENABLE_BUNDLED_YAML "enable bundled yaml" False)
option(ENABLE_BUNDLED_PROTOBUF "enable bundled protobuf" False)

option(ENABLE_LOGS_MANAGEMENT_TESTS "enable logs management tests" True)

option(ENABLE_SENTRY "enable sentry" False)
option(ENABLE_WEBRTC "enable webrtc" False)

if(ENABLE_ACLK OR ENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE)
        set(NEED_PROTOBUF True)
else()
        set(NEED_PROTOBUF False)
endif()

if(ENABLE_PLUGIN_GO)
    include(NetdataGoTools)

    find_min_go_version("${CMAKE_SOURCE_DIR}/src/go")

    find_package(Go "${MIN_GO_VERSION}" REQUIRED)
endif()

if(ENABLE_SENTRY)
        include(FetchContent)

        # ignore debhelper
        set(FETCHCONTENT_FULLY_DISCONNECTED Off)

        set(SENTRY_VERSION 0.6.6)
        set(SENTRY_BACKEND "breakpad")
        set(SENTRY_BUILD_SHARED_LIBS OFF)

        FetchContent_Declare(
                sentry
                URL https://github.com/getsentry/sentry-native/releases/download/${SENTRY_VERSION}/sentry-native.zip
                URL_HASH SHA256=7a98467c0b2571380a3afc5e681cb13aa406a709529be12d74610b0015ccde0c
        )
        FetchContent_MakeAvailable(sentry)
endif()

if(ENABLE_WEBRTC)
        include(FetchContent)

        # ignore debhelper
        set(FETCHCONTENT_FULLY_DISCONNECTED Off)

        set(PREFER_SYSTEM_LIB True)
        set(NO_MEDIA True)
        set(NO_WEBSOCKET True)

        set(HAVE_LIBDATACHANNEL True)

        FetchContent_Declare(libdatachannel
            GIT_REPOSITORY https://github.com/paullouisageneau/libdatachannel.git
            GIT_TAG v0.20.1
        )
        FetchContent_MakeAvailable(libdatachannel)
endif()

if(NEED_PROTOBUF)
        include(NetdataProtobuf)

        if(ENABLE_BUNDLED_PROTOBUF)
                netdata_bundle_protobuf()
        endif()
endif()

#
# handling of extra compiler flags
#

include(NetdataCompilerFlags)

# Disable hardening for debug builds by default.
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        option(DISABLE_HARDENING "disable adding extra compiler flags for hardening" TRUE)
else()
        option(DISABLE_HARDENING "disable adding extra compiler flags for hardening" FALSE)
endif()

set(EXTRA_HARDENING_C_FLAGS "")
set(EXTRA_HARDENING_CXX_FLAGS "")

set(EXTRA_OPT_C_FLAGS "")
set(EXTRA_OPT_CXX_FLAGS "")

if(NOT ${DISABLE_HARDENING})
        add_double_extra_compiler_flag("stack-protector" "-fstack-protector-strong" "-fstack-protector" EXTRA_HARDENING)
        add_double_extra_compiler_flag("_FORTIFY_SOURCE" "-D_FORTIFY_SOURCE=3" "-D_FORTIFY_SOURCE=2" EXTRA_HARDENING)
        add_simple_extra_compiler_flag("stack-clash-protection" "-fstack-clash-protection" EXTRA_HARDENING)
        add_simple_extra_compiler_flag("-fcf-protection" "-fcf-protection=full" EXTRA_HARDENING)
        add_simple_extra_compiler_flag("branch-protection" "-mbranch-protection=standard" EXTRA_HARDENING)
endif()

foreach(FLAG function-sections data-sections)
        add_simple_extra_compiler_flag("${FLAG}" "-f${FLAG}" EXTRA_OPT)
endforeach()

add_simple_extra_compiler_flag("-Wbuiltin-macro-redefined" "-Wno-builtin-macro-redefined" EXTRA_OPT)

foreach(RELTYP RELEASE DEBUG RELWITHDEBINFO MINSIZEREL)
        foreach(L C CXX)
                set(CMAKE_${L}_FLAGS_${RELTYP} "${CMAKE_${L}_FLAGS_${RELTYP}} ${EXTRA_HARDENING_C_FLAGS} ${EXTRA_OPT_C_FLAGS}")
        endforeach()
endforeach()

#
# detect OS
#

set(LINUX   False)
set(FREEBSD False)
set(MACOS   False)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        set(MACOS True)
        set(COMPILED_FOR_MACOS True)

        find_library(IOKIT IOKit)
        find_library(FOUNDATION Foundation)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
        set(FREEBSD True)
        set(COMPILED_FOR_FREEBSD True)
else()
        set(LINUX True)
        set(COMPILED_FOR_LINUX True)
        add_definitions(-D_GNU_SOURCE)
endif()

#
# Libm
#

# checks link with cmake required libs
cmake_policy(SET CMP0075 NEW)

include(CheckFunctionExists)

check_function_exists(log10 HAVE_LOG10)
if(NOT HAVE_LOG10)
        unset(HAVE_LOG10 CACHE)
        list(APPEND CMAKE_REQUIRED_LIBRARIES m)
        check_function_exists(log10 HAVE_LOG10)
        if(HAVE_LOG10)
                set(LINK_LIBM True CACHE BOOL "" FORCE)
        else()
                message(FATAL_ERROR "Can not use log10 with/without libm.")
        endif()
endif()

#
# Custom modules
#

include(NetdataYAML)

#
# Checks from custom modules
#

netdata_detect_libyaml()

#
# check include files
#

include(CheckIncludeFile)

check_include_file("netinet/in.h" HAVE_NETINET_IN_H)
check_include_file("resolv.h" HAVE_RESOLV_H)
check_include_file("netdb.h" HAVE_NETDB_H)
check_include_file("sys/prctl.h" HAVE_SYS_PRCTL_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/vfs.h" HAVE_SYS_VFS_H)
check_include_file("sys/statfs.h" HAVE_SYS_STATFS_H)
check_include_file("linux/magic.h" HAVE_LINUX_MAGIC_H)
check_include_file("sys/mount.h" HAVE_SYS_MOUNT_H)
check_include_file("sys/statvfs.h" HAVE_SYS_STATVFS_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("sys/capability.h" HAVE_SYS_CAPABILITY_H)

#
# check libraries we need
#

include(CheckLibraryExists)

check_library_exists(snappy snappy_compress "" HAVE_SNAPPY_LIB)
#check_include_file("snappy.h" HAVE_SNAPPY_H)

#
# check symbols
#

include(CheckSymbolExists)
check_symbol_exists(major "sys/sysmacros.h" MAJOR_IN_SYSMACROS)
check_symbol_exists(major "sys/mkdev.h" MAJOR_IN_MKDEV)
check_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
check_symbol_exists(strerror_r "string.h" HAVE_STRERROR_R)
check_symbol_exists(finite "math.h" HAVE_FINITE)
check_symbol_exists(isfinite "math.h" HAVE_ISFINITE)
check_symbol_exists(dlsym "dlfcn.h" HAVE_DLSYM)

check_function_exists(nice HAVE_NICE)
check_function_exists(recvmmsg HAVE_RECVMMSG)
check_function_exists(getpriority HAVE_GETPRIORITY)

check_function_exists(sched_getscheduler HAVE_SCHED_GETSCHEDULER)
check_function_exists(sched_setscheduler HAVE_SCHED_SETSCHEDULER)
check_function_exists(sched_get_priority_min HAVE_SCHED_GET_PRIORITY_MIN)
check_function_exists(sched_get_priority_max HAVE_SCHED_GET_PRIORITY_MAX)

check_function_exists(close_range HAVE_CLOSE_RANGE)
check_function_exists(backtrace HAVE_BACKTRACE)

#
# check source compilation
#

include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)

set(CMAKE_REQUIRED_LIBRARIES pthread)
check_c_source_compiles("
#define _GNU_SOURCE
#include <pthread.h>
int main() {
        char name[16];
        pthread_t thread = pthread_self();
        return pthread_getname_np(thread, name, sizeof(name));
}
" HAVE_PTHREAD_GETNAME_NP)

check_c_source_compiles("
#include <stdio.h>
#define mytype(X) _Generic((X), int: 'i', float: 'f', default: 'u')
int main() {
        char type = mytype(0);
        return 0;
}
" HAVE_C__GENERIC)

check_c_source_compiles("
#include <malloc.h>
int main() {
        mallopt(M_ARENA_MAX, 1);
        mallopt(M_PERTURB, 0x5A);
        return 0;
}
" HAVE_C_MALLOPT)

check_c_source_compiles("
#define _GNU_SOURCE
#include <stdio.h>
#include <sys/socket.h>
int main() {
        accept4(0, NULL, NULL, 0);
        return 0;
}
" HAVE_ACCEPT4)

check_c_source_compiles("
#define _GNU_SOURCE
#include <string.h>
int main() {
        char x = *strerror_r(0, &x, sizeof(x)); return 0;
}
" STRERROR_R_CHAR_P)

check_c_source_compiles("
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <sched.h>
int main() {
        setns(0, 0); return 0;
}
" HAVE_SETNS)

check_cxx_source_compiles("
int main() {
        __atomic_load_8(nullptr, 0);
        return 0;
}
" HAVE_BUILTIN_ATOMICS)

check_c_source_compiles("
void my_printf(char const *s, ...) __attribute__((format(printf, 1, 2)));
int main() { return 0; }

=== packaging/dag/requirements.txt ===
click==8.1.7
dagger-io==0.9.7
Jinja2==3.1.3

=== src/fluent-bit/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(fluent-bit C)

# CMP0069 ensures that LTO is enabled for all compilers
cmake_policy(SET CMP0069 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)

# Fluent Bit Version
set(FLB_VERSION_MAJOR  2)
set(FLB_VERSION_MINOR  1)
set(FLB_VERSION_PATCH  10)
set(FLB_VERSION_STR "${FLB_VERSION_MAJOR}.${FLB_VERSION_MINOR}.${FLB_VERSION_PATCH}")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Define macro to identify Windows system (without Cygwin)
if(CMAKE_SYSTEM_NAME MATCHES "Windows")
  set(FLB_SYSTEM_WINDOWS On)
  add_definitions(-DFLB_SYSTEM_WINDOWS)
endif()

# Define macro to identify macOS system
if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
  set(FLB_SYSTEM_MACOS On)
  add_definitions(-DFLB_SYSTEM_MACOS)
endif()

# Define macro to identify Linux system
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(FLB_SYSTEM_LINUX On)
  add_definitions(-DFLB_SYSTEM_LINUX)
endif()

# Update CFLAGS
if (MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_CRT_NONSTDC_NO_WARNINGS)

  # Use custom CFLAGS for MSVC
  #
  #   /Zi ...... Generate pdb files.
  #   /MT ...... Static link C runtimes.
  #   /wd4711 .. C4711 (function selected for inline expansion)
  #   /wd4100 .. C4100 (unreferenced formal parameter)
  #   /wd5045 .. C5045 (Spectre mitigation)
  #
  set(CMAKE_C_FLAGS "/DWIN32 /D_WINDOWS /DNDEBUG /O2 /Zi /wd4100 /wd4711 /wd5045")
  set(CMAKE_EXE_LINKER_FLAGS "/Debug /INCREMENTAL:NO")
  set(CMAKE_BUILD_TYPE None)

  # Use add_compile_options() to set /MT since Visual Studio
  # Generator does not notice /MT in CMAKE_C_FLAGS.
  add_compile_options(/MT)
else()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
  # The following flags are to enhance security, but it may impact performance,
  # we disable them by default.
  if (FLB_WASM_STACK_PROTECT)
    if (WAMR_BUILD_TARGET MATCHES "X86_.*" OR WAMR_BUILD_TARGET STREQUAL "AMD_64")
      set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftrapv -D_FORTIFY_SOURCE=2")
    endif ()
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong --param ssp-buffer-size=4")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wl,-z,noexecstack,-z,relro,-z,now")
  endif()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__FLB_FILENAME__=__FILE__")

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "armv7l")
  set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -latomic")
  set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} -latomic")
endif()
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(FLB_SYSTEM_FREEBSD On)
  add_definitions(-DFLB_SYSTEM_FREEBSD)
  set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -lutil")
  set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} -lutil")
endif()

# *BSD is not supported platform for wasm-micro-runtime except for FreeBSD.
# Now, we should be disabled for these platforms.
if(NOT FLB_SYSTEM_FREEBSD AND ${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  message(STATUS "This platform is not supported for WASM feature so disabled.")
  set(FLB_WASM OFF)
elseif(FLB_SYSTEM_FREEBSD)
  message(STATUS "Some of FreeBSD environment do not work with hardware boundary check so disabled.")
  set(WAMR_DISABLE_STACK_HW_BOUND_CHECK 1)
endif()

include(GNUInstallDirs)
include(ExternalProject)
include(cmake/FindJournald.cmake)
include(cmake/FindMonkey.cmake)
include(cmake/macros.cmake)
include(cmake/platform_feature_checks.cmake)
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/sanitizers-cmake/cmake" ${CMAKE_MODULE_PATH})
find_package(Sanitizers)

# Output paths
set(FLB_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/library")

# Build Options
option(FLB_ALL                 "Enable all features"                         No)
option(FLB_DEBUG               "Build with debug mode (-g)"                 Yes)
option(FLB_RELEASE             "Build with release mode (-O2 -g -DNDEBUG)"   No)
set(FLB_IPO "ReleaseOnly" CACHE STRING "Build with interprocedural optimization")
set_property(CACHE FLB_IPO PROPERTY STRINGS "On;Off;ReleaseOnly")
option(FLB_SMALL               "Optimise for small size"       No)
option(FLB_COVERAGE            "Build with code-coverage"      No)
option(FLB_JEMALLOC            "Build with Jemalloc support"   No)
option(FLB_REGEX               "Build with Regex support"     Yes)
option(FLB_UTF8_ENCODER        "Build with UTF8 encoding support" Yes)
option(FLB_PARSER              "Build with Parser support"    Yes)
option(FLB_TLS                 "Build with SSL/TLS support"   Yes)
option(FLB_BINARY              "Build executable binary"      Yes)
option(FLB_EXAMPLES            "Build examples"               Yes)
option(FLB_SHARED_LIB          "Build shared library"         Yes)
option(FLB_VALGRIND            "Enable Valgrind support"       No)
option(FLB_TRACE               "Enable trace mode"             No)
option(FLB_CHUNK_TRACE         "Enable chunk traces"          Yes)
option(FLB_TESTS_RUNTIME       "Enable runtime tests"          No)
option(FLB_TESTS_INTERNAL      "Enable internal tests"         No)
option(FLB_TESTS_INTERNAL_FUZZ "Enable internal fuzz tests"    No)
option(FLB_TESTS_OSSFUZZ       "Enable OSS-Fuzz build"         No)
option(FLB_MTRACE              "Enable mtrace support"         No)
option(FLB_POSIX_TLS           "Force POSIX thread storage"    No)
option(FLB_INOTIFY             "Enable inotify support"       Yes)
option(FLB_SQLDB               "Enable SQL embedded DB"       Yes)
option(FLB_HTTP_SERVER         "Enable HTTP Server"           Yes)
option(FLB_BACKTRACE           "Enable stacktrace support"    Yes)
option(FLB_LUAJIT              "Enable Lua Scripting support" Yes)
option(FLB_RECORD_ACCESSOR     "Enable record accessor"       Yes)
option(FLB_SIGNV4              "Enable AWS Signv4 support"    Yes)
option(FLB_AWS                 "Enable AWS support"           Yes)
option(FLB_STATIC_CONF         "Build binary using static configuration")
option(FLB_STREAM_PROCESSOR    "Enable Stream Processor"                    Yes)
option(FLB_CORO_STACK_SIZE     "Set coroutine stack size")
option(FLB_AVRO_ENCODER        "Build with Avro encoding support"            No)
option(FLB_AWS_ERROR_REPORTER  "Build with aws error reporting support"      No)
option(FLB_ARROW               "Build with Apache Arrow support"             No)
option(FLB_WINDOWS_DEFAULTS    "Build with predefined Windows settings"     Yes)
option(FLB_WASM                "Build with WASM runtime support"            Yes)
option(FLB_WAMRC               "Build with WASM AOT compiler executable"    No)
option(FLB_WASM_STACK_PROTECT  "Build with WASM runtime with strong stack protector flags" No)

# Native Metrics Support (cmetrics)
option(FLB_METRICS             "Enable metrics support"       Yes)

# Proxy Plugins
option(FLB_PROXY_GO            "Enable Go plugins support"    Yes)

# Built-in Custom Plugins
option(FLB_CUSTOM_CALYPTIA     "Enable Calyptia Support"      Yes)

# Config formats
option(FLB_CONFIG_YAML         "Enable YAML config format"    Yes)

# Built-in Plugins
option(FLB_IN_CPU                      "Enable CPU input plugin"                      Yes)
option(FLB_IN_THERMAL                  "Enable Thermal plugin"                        Yes)
option(FLB_IN_DISK                     "Enable Disk input plugin"                     Yes)
option(FLB_IN_DOCKER                   "Enable Docker input plugin"                   Yes)
option(FLB_IN_DOCKER_EVENTS            "Enable Docker events input plugin"            Yes)
option(FLB_IN_EXEC                     "Enable Exec input plugin"                     Yes)
option(FLB_IN_EXEC_WASI                "Enable Exec WASI input plugin"                Yes)
option(FLB_IN_EVENT_TEST               "Enable Events test plugin"                    Yes)
option(FLB_IN_EVENT_TYPE               "Enable event type plugin"                     Yes)
option(FLB_IN_FLUENTBIT_METRICS        "Enable Fluent Bit metrics  plugin"            Yes)
option(FLB_IN_FORWARD                  "Enable Forward input plugin"                  Yes)
option(FLB_IN_HEALTH                   "Enable Health input plugin"                   Yes)
option(FLB_IN_HTTP                     "Enable HTTP input plugin"                     Yes)
option(FLB_IN_MEM                      "Enable Memory input plugin"                   Yes)
option(FLB_IN_KUBERNETES_EVENTS        "Enable Kubernetes Events plugin"              Yes)
option(FLB_IN_KAFKA                    "Enable Kafka input plugin"                    Yes)
option(FLB_IN_KMSG                     "Enable Kernel log input plugin"               Yes)
option(FLB_IN_LIB                      "Enable library mode input plugin"             Yes)
option(FLB_IN_RANDOM                   "Enable random input plugin"                   Yes)
option(FLB_IN_SERIAL                   "Enable Serial input plugin"                   Yes)
option(FLB_IN_STDIN                    "Enable Standard input plugin"                 Yes)
option(FLB_IN_SYSLOG                   "Enable Syslog input plugin"                   Yes)
option(FLB_IN_TAIL                     "Enable Tail input plugin"                     Yes)
option(FLB_IN_UDP                      "Enable UDP input plugin"                      Yes)
option(FLB_IN_TCP                      "Enable TCP input plugin"                      Yes)
option(FLB_IN_UNIX_SOCKET              "Enable Unix socket input plugin"               No)
option(FLB_IN_MQTT                     "Enable MQTT Broker input plugin"              Yes)
option(FLB_IN_HEAD                     "Enable Head input plugin"                     Yes)
option(FLB_IN_PROC                     "Enable Process input plugin"                  Yes)
option(FLB_IN_SYSTEMD                  "Enable Systemd input plugin"                  Yes)
option(FLB_IN_DUMMY                    "Enable Dummy input plugin"                    Yes)
option(FLB_IN_NGINX_EXPORTER_METRICS   "Enable Nginx Metrics input plugin"            Yes)
option(FLB_IN_NETIF                    "Enable NetworkIF input plugin"                Yes)
option(FLB_IN_WINLOG                   "Enable Windows Log input plugin"               No)
option(FLB_IN_WINSTAT                  "Enable Windows Stat input plugin"              No)
option(FLB_IN_WINEVTLOG                "Enable Windows EvtLog input plugin"            No)
option(FLB_IN_COLLECTD                 "Enable Collectd input plugin"                 Yes)
option(FLB_IN_PROMETHEUS_SCRAPE        "Enable Promeheus Scrape input plugin"         Yes)
option(FLB_IN_STATSD                   "Enable StatsD input plugin"                   Yes)
option(FLB_IN_EVENT_TEST               "Enable event test plugin"                      No)
option(FLB_IN_STORAGE_BACKLOG          "Enable storage backlog input plugin"          Yes)
option(FLB_IN_EMITTER                  "Enable emitter input plugin"                  Yes)
option(FLB_IN_NODE_EXPORTER_METRICS    "Enable node exporter metrics input plugin"    Yes)
option(FLB_IN_WINDOWS_EXPORTER_METRICS "Enable windows exporter metrics input plugin" Yes)
option(FLB_IN_PODMAN_METRICS           "Enable Podman Metrics input plugin"           Yes)
option(FLB_IN_OPENTELEMETRY            "Enable OpenTelemetry input plugin"            Yes)
option(FLB_IN_ELASTICSEARCH            "Enable Elasticsearch (Bulk API) input plugin" Yes)
option(FLB_IN_CALYPTIA_FLEET           "Enable Calyptia Fleet input plugin"           Yes)
option(FLB_IN_SPLUNK                   "Enable Splunk HTTP HEC input plugin"          Yes)
option(FLB_OUT_AZURE                   "Enable Azure output plugin"                   Yes)
option(FLB_OUT_AZURE_BLOB              "Enable Azure output plugin"                   Yes)
option(FLB_OUT_AZURE_LOGS_INGESTION    "Enable Azure Logs Ingestion output plugin"    Yes)
option(FLB_OUT_AZURE_KUSTO             "Enable Azure Kusto output plugin"             Yes)

=== src/fluent-bit/examples/CMakeLists.txt ===
add_subdirectory(hello_world)
if(FLB_OUT_LIB)
  add_subdirectory(out_lib)
endif()

=== src/fluent-bit/include/CMakeLists.txt ===
# Install fluent-bit headers
install(FILES "fluent-bit.h"
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}
    COMPONENT headers
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "fluent-bit/*.h")
install(FILES ${headers}
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/fluent-bit
    COMPONENT headers
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "fluent-bit/config_format/*.h")
install(FILES ${headers}
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/fluent-bit/config_format/
    COMPONENT headers
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "fluent-bit/tls/*.h")
install(FILES ${headers}
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/fluent-bit/tls/
    COMPONENT headers
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "fluent-bit/wasm/*.h")
install(FILES ${headers}
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/fluent-bit/wasm/
    COMPONENT headers
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

install(FILES "../lib/monkey/include/monkey/mk_core.h"
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/monkey/
    COMPONENT headers-extra
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

file(GLOB headers "../lib/monkey/include/monkey/mk_core/*.h")
    install(FILES ${headers}
    COMPONENT headers-extra
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/monkey/mk_core/
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)


file(GLOB headers "../lib/flb_libco/*.h")
    install(FILES ${headers}
    COMPONENT headers-extra
    DESTINATION ${FLB_INSTALL_INCLUDEDIR}/
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== src/fluent-bit/plugins/CMakeLists.txt ===
set(flb_plugins "" CACHE INTERNAL "flb_plugins")

# REGISTER_CUSTOM_PLUGIN
macro(REGISTER_CUSTOM_PLUGIN name)
  string(FIND ${name} "=" pos)
  if(pos GREATER -1)
    string(REPLACE "=" ";" list ${name})
    list(GET list 0 p_name)
    list(GET list 1 p_path)
    message(STATUS "EXTERNAL CUSTOM PLUGIN name='${p_name}' path='${p_path}'")
  else()
    set(p_name ${name})
  endif()

  string(TOUPPER ${p_name} NAME)
  if(FLB_${NAME} OR p_path)
    set(FLB_IN_PLUGINS_DECL "${FLB_CUSTOM_PLUGINS_DECL}extern struct flb_custom_plugin ${p_name}_plugin;\n")

    # C code
    set(C_CODE          "    custom = flb_malloc(sizeof(struct flb_custom_plugin));\n")
    set(C_CODE "${C_CODE}    if (!custom) {\n")
    set(C_CODE "${C_CODE}        flb_errno();\n")
    set(C_CODE "${C_CODE}        return -1;\n")
    set(C_CODE "${C_CODE}    }\n")
    set(C_CODE "${C_CODE}    memcpy(custom, &${p_name}_plugin, sizeof(struct flb_custom_plugin));\n")
    set(C_CODE "${C_CODE}    mk_list_add(&custom->_head, &config->custom_plugins);\n\n")

    set(FLB_IN_PLUGINS_ADD "${FLB_CUSTOM_PLUGINS_ADD}${C_CODE}")

    if (p_path)
      add_subdirectory(${p_path} ${p_path})
    else()
      add_subdirectory(${p_name})
    endif()
    set(flb_plugins "${flb_plugins}flb-plugin-${p_name};")
  endif()
endmacro()

# REGISTER_IN_PLUGIN
macro(REGISTER_IN_PLUGIN name)
  string(FIND ${name} "=" pos)
  if(pos GREATER -1)
    string(REPLACE "=" ";" list ${name})
    list(GET list 0 p_name)
    list(GET list 1 p_path)
    message(STATUS "EXTERNAL IN PLUGIN name='${p_name}' path='${p_path}'")
  else()
    set(p_name ${name})
  endif()

  string(TOUPPER ${p_name} NAME)
  if(FLB_${NAME} OR p_path)
    set(FLB_IN_PLUGINS_DECL "${FLB_IN_PLUGINS_DECL}extern struct flb_input_plugin ${p_name}_plugin;\n")

    # C code
    set(C_CODE          "    in = flb_malloc(sizeof(struct flb_input_plugin));\n")
    set(C_CODE "${C_CODE}    if (!in) {\n")
    set(C_CODE "${C_CODE}        flb_errno();\n")
    set(C_CODE "${C_CODE}        return -1;\n")
    set(C_CODE "${C_CODE}    }\n")
    set(C_CODE "${C_CODE}    memcpy(in, &${p_name}_plugin, sizeof(struct flb_input_plugin));\n")
    set(C_CODE "${C_CODE}    mk_list_add(&in->_head, &config->in_plugins);\n\n")

    set(FLB_IN_PLUGINS_ADD "${FLB_IN_PLUGINS_ADD}${C_CODE}")

    if (p_path)
      add_subdirectory(${p_path} ${p_path})
    else()
      add_subdirectory(${p_name})
    endif()
    set(flb_plugins "${flb_plugins}flb-plugin-${p_name};")
  endif()
endmacro()

# REGISTER_OUT_PLUGIN
macro(REGISTER_OUT_PLUGIN name)
  string(FIND ${name} "=" pos)
  if(pos GREATER -1)
    string(REPLACE "=" ";" list ${name})
    list(GET list 0 p_name)
    list(GET list 1 p_path)
    message(STATUS "EXTERNAL OUT PLUGIN name='${p_name}' path='${p_path}'")
  else()
    set(p_name ${name})
  endif()

  string(TOUPPER ${p_name} NAME)
  if(FLB_${NAME} OR p_path)
    set(FLB_OUT_PLUGINS_DECL "${FLB_OUT_PLUGINS_DECL}extern struct flb_output_plugin ${p_name}_plugin;\n")

    # C code
    set(C_CODE          "    out = flb_malloc(sizeof(struct flb_output_plugin));\n")
    set(C_CODE "${C_CODE}    if (!out) {\n")
    set(C_CODE "${C_CODE}        flb_errno();\n")
    set(C_CODE "${C_CODE}        return -1;\n")
    set(C_CODE "${C_CODE}    }\n")
    set(C_CODE "${C_CODE}    memcpy(out, &${p_name}_plugin, sizeof(struct flb_output_plugin));\n")
    set(C_CODE "${C_CODE}    mk_list_add(&out->_head, &config->out_plugins);\n\n")

    set(FLB_OUT_PLUGINS_ADD "${FLB_OUT_PLUGINS_ADD}${C_CODE}")
    if (p_path)
      add_subdirectory(${p_path} ${p_path})
    else()
      add_subdirectory(${p_name})
    endif()
    set(flb_plugins "${flb_plugins}flb-plugin-${p_name};")
  endif()
endmacro()


# REGISTER_PROCESSOR_PLUGIN
macro(REGISTER_PROCESSOR_PLUGIN name)
  string(FIND ${name} "=" pos)
  if(pos GREATER -1)
    string(REPLACE "=" ";" list ${name})
    list(GET list 0 p_name)
    list(GET list 1 p_path)
    message(STATUS "EXTERNAL PROCESSOR PLUGIN name='${p_name}' path='${p_path}'")
  else()
    set(p_name ${name})
  endif()

  string(TOUPPER ${p_name} NAME)
  if(FLB_${NAME} OR p_path)
    set(FLB_PROCESSOR_PLUGINS_DECL "${FLB_PROCESSOR_PLUGINS_DECL}extern struct flb_processor_plugin ${p_name}_plugin;\n")

    # C code
    set(C_CODE          "    processor = flb_malloc(sizeof(struct flb_processor_plugin));\n")
    set(C_CODE "${C_CODE}    if (!processor) {\n")
    set(C_CODE "${C_CODE}        flb_errno();\n")
    set(C_CODE "${C_CODE}        return -1;\n")
    set(C_CODE "${C_CODE}    }\n")
    set(C_CODE "${C_CODE}    memcpy(processor, &${p_name}_plugin, sizeof(struct flb_processor_plugin));\n")
    set(C_CODE "${C_CODE}    mk_list_add(&processor->_head, &config->processor_plugins);\n\n")

    set(FLB_PROCESSOR_PLUGINS_ADD "${FLB_PROCESSOR_PLUGINS_ADD}${C_CODE}")
    if (p_path)
      add_subdirectory(${p_path} ${p_path})
    else()
      add_subdirectory(${p_name})
    endif()
    set(flb_plugins "${flb_plugins}flb-plugin-${p_name};")
  endif()
endmacro()

# REGISTER_FILTER_PLUGIN
macro(REGISTER_FILTER_PLUGIN name)
  string(FIND ${name} "=" pos)
  if(pos GREATER -1)
    string(REPLACE "=" ";" list ${name})
    list(GET list 0 p_name)
    list(GET list 1 p_path)
    message(STATUS "EXTERNAL FILTER PLUGIN name='${p_name}' path='${p_path}'")
  else()
    set(p_name ${name})
  endif()

  string(TOUPPER ${p_name} NAME)
  if(FLB_${NAME} OR p_path)
    set(FLB_FILTER_PLUGINS_DECL "${FLB_FILTER_PLUGINS_DECL}extern struct flb_filter_plugin ${p_name}_plugin;\n")

    # C code
    set(C_CODE          "    filter = flb_malloc(sizeof(struct flb_filter_plugin));\n")
    set(C_CODE "${C_CODE}    if (!filter) {\n")
    set(C_CODE "${C_CODE}        flb_errno();\n")
    set(C_CODE "${C_CODE}        return -1;\n")
    set(C_CODE "${C_CODE}    }\n")
    set(C_CODE "${C_CODE}    memcpy(filter, &${p_name}_plugin, sizeof(struct flb_filter_plugin));\n")
    set(C_CODE "${C_CODE}    mk_list_add(&filter->_head, &config->filter_plugins);\n\n")

    set(FLB_FILTER_PLUGINS_ADD "${FLB_FILTER_PLUGINS_ADD}${C_CODE}")
    if (p_path)
      add_subdirectory(${p_path} ${p_path})
    else()
      add_subdirectory(${p_name})
    endif()
    set(flb_plugins "${flb_plugins}flb-plugin-${p_name};")
  endif()
endmacro()

# FLB_PLUGIN: used by plugins to perform registration and linking
macro(FLB_PLUGIN name src deps)
  add_library(flb-plugin-${name} STATIC ${src})
  add_sanitizers(flb-plugin-${name})
  target_link_libraries(flb-plugin-${name} fluent-bit-static msgpack-c-static ${deps})
endmacro()


# ======================
#  Plugins Registration
# ======================

# Custom Plugins
REGISTER_CUSTOM_PLUGIN("custom_calyptia")

# These plugins works only on Linux
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  REGISTER_IN_PLUGIN("in_cpu")
  REGISTER_IN_PLUGIN("in_mem")
  REGISTER_IN_PLUGIN("in_thermal")
  REGISTER_IN_PLUGIN("in_kmsg")
  REGISTER_IN_PLUGIN("in_proc")
  REGISTER_IN_PLUGIN("in_disk")
  REGISTER_IN_PLUGIN("in_systemd")
  REGISTER_IN_PLUGIN("in_netif")
  REGISTER_IN_PLUGIN("in_docker")
  REGISTER_IN_PLUGIN("in_docker_events")
  REGISTER_IN_PLUGIN("in_node_exporter_metrics")
  REGISTER_IN_PLUGIN("in_podman_metrics")
endif()

REGISTER_IN_PLUGIN("in_kubernetes_events")
REGISTER_IN_PLUGIN("in_kafka")
REGISTER_IN_PLUGIN("in_fluentbit_metrics")
REGISTER_IN_PLUGIN("in_prometheus_scrape")
REGISTER_IN_PLUGIN("in_emitter")
REGISTER_IN_PLUGIN("in_tail")
REGISTER_IN_PLUGIN("in_dummy")
REGISTER_IN_PLUGIN("in_head")
REGISTER_IN_PLUGIN("in_health")
REGISTER_IN_PLUGIN("in_http")
REGISTER_IN_PLUGIN("in_collectd")
REGISTER_IN_PLUGIN("in_statsd")
REGISTER_IN_PLUGIN("in_opentelemetry")
REGISTER_IN_PLUGIN("in_elasticsearch")
REGISTER_IN_PLUGIN("in_calyptia_fleet")
REGISTER_IN_PLUGIN("in_splunk")

# Test the event loop messaging when used in threaded mode
REGISTER_IN_PLUGIN("in_event_test")

# Send different event types: logs, metrics and traces
REGISTER_IN_PLUGIN("in_event_type")


if (FLB_IN_STORAGE_BACKLOG)
  REGISTER_IN_PLUGIN("in_storage_backlog")
endif()

REGISTER_IN_PLUGIN("in_nginx_exporter_metrics")

if (FLB_STREAM_PROCESSOR)
  REGISTER_IN_PLUGIN("in_stream_processor")
endif()

if (FLB_SYSTEM_WINDOWS)
  REGISTER_IN_PLUGIN("in_winlog")
  REGISTER_IN_PLUGIN("in_winstat")
  REGISTER_IN_PLUGIN("in_winevtlog")
  REGISTER_IN_PLUGIN("in_windows_exporter_metrics")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W2")
else()
  REGISTER_IN_PLUGIN("in_serial")
endif()

if(FLB_REGEX)
  REGISTER_IN_PLUGIN("in_stdin")
endif()

if(FLB_PARSER)
  REGISTER_IN_PLUGIN("in_syslog")
  REGISTER_IN_PLUGIN("in_exec")
endif()

REGISTER_IN_PLUGIN("in_udp")

if(FLB_WASM)
  REGISTER_IN_PLUGIN("in_exec_wasi")
endif()

REGISTER_IN_PLUGIN("in_tcp")
REGISTER_IN_PLUGIN("in_unix_socket")
REGISTER_IN_PLUGIN("in_mqtt")
REGISTER_IN_PLUGIN("in_lib")
REGISTER_IN_PLUGIN("in_forward")
REGISTER_IN_PLUGIN("in_random")

# PROCESSORS
# ==========
REGISTER_PROCESSOR_PLUGIN("processor_labels")
REGISTER_PROCESSOR_PLUGIN("processor_attributes")

# OUTPUTS
# =======
REGISTER_OUT_PLUGIN("out_azure")
REGISTER_OUT_PLUGIN("out_azure_blob")
REGISTER_OUT_PLUGIN("out_azure_logs_ingestion")
REGISTER_OUT_PLUGIN("out_azure_kusto")
REGISTER_OUT_PLUGIN("out_bigquery")
REGISTER_OUT_PLUGIN("out_calyptia")
REGISTER_OUT_PLUGIN("out_counter")
REGISTER_OUT_PLUGIN("out_datadog")
REGISTER_OUT_PLUGIN("out_es")
REGISTER_OUT_PLUGIN("out_exit")
REGISTER_OUT_PLUGIN("out_file")
REGISTER_OUT_PLUGIN("out_forward")
REGISTER_OUT_PLUGIN("out_http")
REGISTER_OUT_PLUGIN("out_influxdb")
REGISTER_OUT_PLUGIN("out_logdna")
REGISTER_OUT_PLUGIN("out_loki")
REGISTER_OUT_PLUGIN("out_kafka")
REGISTER_OUT_PLUGIN("out_kafka_rest")
REGISTER_OUT_PLUGIN("out_nats")
REGISTER_OUT_PLUGIN("out_nrlogs")
REGISTER_OUT_PLUGIN("out_null")
REGISTER_OUT_PLUGIN("out_opensearch")
REGISTER_OUT_PLUGIN("out_oracle_log_analytics")

if (NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
  REGISTER_OUT_PLUGIN("out_plot")
endif()

REGISTER_OUT_PLUGIN("out_pgsql")
REGISTER_OUT_PLUGIN("out_retry")
REGISTER_OUT_PLUGIN("out_skywalking")
REGISTER_OUT_PLUGIN("out_slack")
REGISTER_OUT_PLUGIN("out_splunk")
REGISTER_OUT_PLUGIN("out_stackdriver")
REGISTER_OUT_PLUGIN("out_stdout")
REGISTER_OUT_PLUGIN("out_syslog")
REGISTER_OUT_PLUGIN("out_tcp")
REGISTER_OUT_PLUGIN("out_udp")
REGISTER_OUT_PLUGIN("out_td")
REGISTER_OUT_PLUGIN("out_lib")
REGISTER_OUT_PLUGIN("out_flowcounter")
REGISTER_OUT_PLUGIN("out_gelf")
REGISTER_OUT_PLUGIN("out_websocket")
REGISTER_OUT_PLUGIN("out_cloudwatch_logs")
REGISTER_OUT_PLUGIN("out_kinesis_firehose")
REGISTER_OUT_PLUGIN("out_kinesis_streams")
REGISTER_OUT_PLUGIN("out_opentelemetry")
REGISTER_OUT_PLUGIN("out_prometheus_exporter")
REGISTER_OUT_PLUGIN("out_prometheus_remote_write")
REGISTER_OUT_PLUGIN("out_s3")
REGISTER_OUT_PLUGIN("out_vivo_exporter")
REGISTER_OUT_PLUGIN("out_chronicle")

# FILTERS
# =======
REGISTER_FILTER_PLUGIN("filter_alter_size")
REGISTER_FILTER_PLUGIN("filter_aws")
REGISTER_FILTER_PLUGIN("filter_checklist")
REGISTER_FILTER_PLUGIN("filter_ecs")
REGISTER_FILTER_PLUGIN("filter_record_modifier")
REGISTER_FILTER_PLUGIN("filter_throttle")
REGISTER_FILTER_PLUGIN("filter_throttle_size")
REGISTER_FILTER_PLUGIN("filter_tensorflow")
REGISTER_FILTER_PLUGIN("filter_type_converter")

if(FLB_REGEX)
  REGISTER_FILTER_PLUGIN("filter_kubernetes")
  REGISTER_FILTER_PLUGIN("filter_modify")
  REGISTER_FILTER_PLUGIN("filter_multiline")
  REGISTER_FILTER_PLUGIN("filter_nest")
  REGISTER_FILTER_PLUGIN("filter_parser")
endif()

if(FLB_RECORD_ACCESSOR)
  REGISTER_FILTER_PLUGIN("filter_expect")
  REGISTER_FILTER_PLUGIN("filter_grep")
  REGISTER_FILTER_PLUGIN("filter_rewrite_tag")
endif()

if(FLB_METRICS)
  REGISTER_FILTER_PLUGIN("filter_log_to_metrics")
endif()

if(FLB_LUAJIT)
  REGISTER_FILTER_PLUGIN("filter_lua")
endif()

REGISTER_FILTER_PLUGIN("filter_stdout")

REGISTER_FILTER_PLUGIN("filter_geoip2")

REGISTER_FILTER_PLUGIN("filter_nightfall")
if (FLB_WASM)
  REGISTER_FILTER_PLUGIN("filter_wasm")
endif ()

# Register external input and output plugins
if(EXT_IN_PLUGINS)

=== src/fluent-bit/examples/filter_rust_clib/Makefile ===
WASI_SDK_ROOT ?= /opt/wasi-sdk
STACK_SIZE ?= 8192
INITIAL_MEMORY_SIZE ?= 65536

rustclib:
	cargo build --target wasm32-unknown-unknown --release

build: wasm rustclib

wasm: rustclib rust_clib_filter.h
	${WASI_SDK_ROOT}/bin/clang -O3 -nostdlib \
		-z stack-size=${STACK_SIZE} -Wl,--initial-memory=${INITIAL_MEMORY_SIZE} \
		-o rust_clib_filter.wasm rust_clib_filter.c \
		-L ./target/wasm32-unknown-unknown/release -lfilter_rust_clib \
		-Wl,--export=__heap_base -Wl,--export=__data_end -Wl,--export=rust_clib_filter \
		-Wl,--no-entry -Wl,--strip-all -Wl,--allow-undefined

rust_clib_filter.h:
	cbindgen --crate filter_rust_clib --output filter_rust_clib.h --lang c


clean:
	rm -f *.wasm
	rm -f *.h
	cargo clean

=== src/fluent-bit/examples/filter_wasm_c/Makefile ===
WASI_SDK_ROOT ?= /opt/wasi-sdk
STACK_SIZE ?= 8192
INITIAL_MEMORY_SIZE ?= 65536

.PHONY: wasm

wasm:
	${WASI_SDK_ROOT}/bin/clang -O3 -nostdlib \
		-z stack-size=${STACK_SIZE} -Wl,--initial-memory=${INITIAL_MEMORY_SIZE} \
		-o c_filter.wasm c_filter.c \
		-Wl,--export=__heap_base -Wl,--export=__data_end -Wl,--export=c_filter \
		-Wl,--no-entry -Wl,--strip-all -Wl,--allow-undefined

clean:
	rm -f *.wasm

=== src/fluent-bit/examples/hello_world/CMakeLists.txt ===
set(src
  ${src}
  hello_world.c
  )

find_package (Threads)
add_executable(hello_world ${src})
target_link_libraries(hello_world fluent-bit-shared)
target_link_libraries(hello_world ${CMAKE_THREAD_LIBS_INIT})

=== src/fluent-bit/examples/kafka_filter/Makefile ===
build:
	docker compose build

start:
	docker compose up -d
	docker compose logs -f fluent-bit kafka-consumer

stop:
	docker compose down

.PHONY: build start stop

=== src/fluent-bit/examples/out_lib/CMakeLists.txt ===
set(src
  ${src}
  out_lib.c
  )

find_package (Threads)
add_executable(out_lib ${src})
target_link_libraries(out_lib fluent-bit-shared)
target_link_libraries(out_lib ${CMAKE_THREAD_LIBS_INIT})

=== src/fluent-bit/lib/avro/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
cmake_minimum_required(VERSION 3.1)
project(AvroC C)
enable_testing()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

# Eliminates warning about linker paths when linking both zlib and
# liblzma.
cmake_policy(SET CMP0003 NEW)

#-----------------------------------------------------------------------
# Retrieve the current version number

if (UNIX)
    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh project
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE AVRO_VERSION_RESULT
        OUTPUT_VARIABLE AVRO_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(AVRO_VERSION_RESULT)
        message(FATAL_ERROR "Cannot determine Avro version number")
    endif(AVRO_VERSION_RESULT)

    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh libtool
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE LIBAVRO_VERSION_RESULT
        OUTPUT_VARIABLE LIBAVRO_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(LIBAVRO_VERSION_RESULT)
        message(FATAL_ERROR "Cannot determine libavro version number")
    endif(LIBAVRO_VERSION_RESULT)

    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh libcurrent
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE LIBAVRO_SOVERSION_RESULT
        OUTPUT_VARIABLE LIBAVRO_SOVERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(LIBAVRO_SOVERSION_RESULT)
        message(FATAL_ERROR "Cannot determine libavro version number")
    endif(LIBAVRO_SOVERSION_RESULT)

else(UNIX)
    # Hard code for win32 -- need to figure out how to port version.sh for
    # Windows.
    set(LIBAVRO_VERSION "22:0:0")
endif(UNIX)


#-----------------------------------------------------------------------
# Extract major.minor.patch from version number

if (UNIX)
    string(REGEX REPLACE "([0-9]+)\\..*"
        "\\1"
        AVRO_MAJOR_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\.([0-9]+)\\..*"
        "\\1"
        AVRO_MINOR_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\..*\\.([0-9]+).*"
        "\\1"
        AVRO_PATCH_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\..*\\.[0-9]+(.*)"
        "\\1"
        AVRO_VERSION_EXTENSION
        ${AVRO_VERSION}
    )
endif(UNIX)

#-----------------------------------------------------------------------
# Source package support

include(CPackConfig.txt)
include(CheckLibraryExists)


if(APPLE)
    if (NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    endif (NOT CMAKE_INSTALL_NAME_DIR)
endif(APPLE)

if(CMAKE_COMPILER_IS_GNUCC)
    add_definitions(-W -Wall)
endif(CMAKE_COMPILER_IS_GNUCC)

if (WIN32)
   # Compile win32 in C++ to allow declarations after statements
   add_definitions(/TP)
endif(WIN32)

# Uncomment to allow missing fields in the resolved-writer
# add_definitions(-DAVRO_ALLOW_MISSING_FIELDS_IN_RESOLVED_WRITER)

# Uncomment to allow non-atomic increment/decrement of reference count
# add_definitions(-DAVRO_ALLOW_NON_ATOMIC_REFCOUNT)

# Thread support (only for *nix with pthreads)
set(THREADS_LIBRARIES)
if(UNIX AND THREADSAFE AND CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_THREAD_PREFER_PTHREAD)
    find_package(Threads)

    if(NOT CMAKE_USE_PTHREADS_INIT)
        message(FATAL_ERROR "pthreads not found")
    endif(NOT CMAKE_USE_PTHREADS_INIT)

    add_definitions(-DTHREADSAFE -D_REENTRANT)
    set(THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif(UNIX AND THREADSAFE AND CMAKE_COMPILER_IS_GNUCC)

include_directories(${AvroC_SOURCE_DIR}/src)


# Enable codecs

find_package(ZLIB)
if (ZLIB_FOUND)
    set(ZLIB_PKG zlib)
    add_definitions(-DDEFLATE_CODEC)
    include_directories(${ZLIB_INCLUDE_DIRS})
    message("Enabled deflate codec")
else (ZLIB_FOUND)
    set(ZLIB_PKG "")
    set(ZLIB_LIBRARIES "")
    message("Disabled deflate codec. zlib not found.")
endif (ZLIB_FOUND)

find_package(Snappy)
if (SNAPPY_FOUND AND ZLIB_FOUND)  # Snappy borrows crc32 from zlib
    set(SNAPPY_PKG libsnappy)
    add_definitions(-DSNAPPY_CODEC)
    include_directories(${SNAPPY_INCLUDE_DIRS})
    message("Enabled snappy codec")
else (SNAPPY_FOUND AND ZLIB_FOUND)
    set(SNAPPY_PKG "")
    set(SNAPPY_LIBRARIES "")
    message("Disabled snappy codec. libsnappy not found or zlib not found.")
endif (SNAPPY_FOUND AND ZLIB_FOUND)

find_package(PkgConfig)
pkg_check_modules(LZMA liblzma)
if (LZMA_FOUND)
    set(LZMA_PKG liblzma)
    add_definitions(-DLZMA_CODEC)
    include_directories(${LZMA_INCLUDE_DIRS})
    link_directories(${LZMA_LIBRARY_DIRS})
    message("Enabled lzma codec")
else (LZMA_FOUND)
    set(LZMA_PKG "")
    set(LZMA_LIBRARIES "")
    message("Disabled lzma codec. liblzma not found.")
endif (LZMA_FOUND)

set(CODEC_LIBRARIES ${ZLIB_LIBRARIES} ${LZMA_LIBRARIES} ${SNAPPY_LIBRARIES})
set(CODEC_PKG "@ZLIB_PKG@ @LZMA_PKG@ @SNAPPY_PKG@")

# updated by edsiper, avro version 77692d8c1
# commented out by mcqueen because jansson is now embedded here 07OCT2020
# Jansson JSON library
#pkg_check_modules(JANSSON jansson>=2.3)
#if (JANSSON_FOUND)
#    set(JANSSON_PKG libjansson)
#    include_directories(${JANSSON_INCLUDE_DIRS})
#    link_directories(${JANSSON_LIBRARY_DIRS})
#else (JANSSON_FOUND)
#    message(FATAL_ERROR "libjansson >=2.3 not found")
#endif (JANSSON_FOUND)

# updated by edsiper, avro version 77692d8c1
# added by mcqueen to get the headers into the fluent-bit build root 07OCT2020
include_directories(${CMAKE_BINARY_DIR}/lib/jansson/include/)

add_subdirectory(src)
#add_subdirectory(examples)
#add_subdirectory(tests)
#add_subdirectory(docs)

add_custom_target(pretty
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake_pretty.cmake")

=== packaging/repoconfig/debian/changelog ===
netdata-repo (2-2) unstable; urgency=medium

  * Version bump to keep in sync with RPM repo packages

 -- Netdata Builder <bot@netdata.cloud>  Mon, 13 Nov 2023 11:15:00 -0500

netdata-repo (2-1) unstable; urgency=medium

  * Switched to new package hosting infrastructure
  * Removed apt-transport-https requirement

 -- Netdata Builder <bot@netdata.cloud>  Wed, 18 Jan 2023 08:30:00 -0500

netdata-repo (1-2) unstable; urgency=medium

  * Fixed package file naming for repo layout compliance

 -- Netdata Builder <bot@netdata.cloud>  Mon, 6 Jun 2022 09:30:00 -0500

netdata-repo (1-1) unstable; urgency=medium

  * Initial Release

 -- Netdata Builder <bot@netdata.cloud>  Mon, 14 Jun 2021 08:00:00 -0500

=== contrib/debian/control ===
Source: netdata
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.13.19),
               bison,
               cmake,
               curl,
               flex,
               golang (>= 1.21),
               libcups2-dev,
               libcurl4-openssl-dev,
               libelf-dev,
               libipmimonitoring-dev,
               libjson-c-dev,
               liblz4-dev,
               libmnl-dev,
               libmongoc-dev,
               libnetfilter-acct-dev,
               libpcre2-dev,
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               libssl-dev,
               libsystemd-dev,
               libuv1-dev,
               libyaml-dev,
               pkg-config,
               protobuf-compiler,
               uuid-dev,
               zlib1g-dev
Section: net
Priority: optional
Maintainer: Netdata Builder <bot@netdata.cloud>
Standards-Version: 3.9.6
Homepage: https://netdata.cloud

Package: netdata
Architecture: any
Depends: openssl,
         ${misc:Depends},
         ${shlibs:Depends},
         netdata-plugin-ebpf (= ${source:Version}) [amd64],
         netdata-plugin-apps (= ${source:Version}),
         netdata-plugin-pythond (= ${source:Version}),
         netdata-plugin-go (= ${source:Version}),
         netdata-plugin-debugfs (= ${source:Version}),
         netdata-plugin-nfacct (= ${source:Version}),
         netdata-plugin-chartsd (= ${source:Version}),
         netdata-plugin-slabinfo (= ${source:Version}),
         netdata-plugin-perf (= ${source:Version})
Pre-Depends: adduser,
             dpkg (>= 1.17.14),
             libcap2-bin (>=1:2.0),
             lsb-base (>= 3.1-23.2)
Conflicts: netdata-core,
           netdata-plugins-bash,
           netdata-plugins-python,
           netdata-web
Suggests: netdata-plugin-cups (= ${source:Version}),
          netdata-plugin-freeipmi (= ${source:Version})
Recommends: netdata-plugin-systemd-journal (= ${source:Version}),
            netdata-plugin-logs-management (= ${source:Version}),
            netdata-plugin-network-viewer (= ${source:Version})
Description: real-time charts for system monitoring
 Netdata is a daemon that collects data in realtime (per second)
 and presents a web site to view and analyze them. The presentation
 is also real-time and full of interactive charts that precisely
 render all collected values.

Package: netdata-plugin-cups
Architecture: any
Depends: cups,
         ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Description: The CUPS metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the Common
 UNIX Printing System.

Package: netdata-plugin-freeipmi
Architecture: any
Depends: freeipmi,
         ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Description: The FreeIPMI metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from hardware
 using FreeIPMI.

Package: netdata-plugin-nfacct
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: The NFACCT metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the firewall
 using NFACCT objects.

Package: netdata-plugin-chartsd
Architecture: all
Depends: bash,
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Suggests: apcupsd, iw, sudo
Description: The charts.d metrics collection plugin for the Netdata Agent
 This plugin adds a selection of additional collectors written in shell
 script to the Netdata Agent. It includes collectors for APCUPSD,
 LibreSWAN, OpenSIPS, and Wireless access point statistics.

Package: netdata-plugin-ebpf
Architecture: amd64
Depends: ${shlibs:Depends},
         netdata (= ${source:Version}),
         netdata-ebpf-code-legacy (= ${source:Version})
Pre-Depends: adduser
Recommends: netdata-plugin-apps (= ${source:Version})
Conflicts: netdata (<< ${source:Version})
Description: The eBPF metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to use eBPF code to collect more
 detailed kernel-level metrics for the system.

Package: netdata-ebpf-code-legacy
Architecture: amd64
Depends: netdata-plugin-ebpf (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: Compiled eBPF legacy code for the Netdata eBPF plugin
 This package provides the pre-compiled eBPF legacy code for use by
 the Netdata eBPF plugin.  This code is only needed when using the eBPF
 plugin with kernel that do not include BTF support (mostly kernel
 versions lower than 5.10)..

Package: netdata-plugin-pythond
Architecture: all
Depends: netdata (= ${source:Version})
Pre-Depends: adduser
Suggests: sudo
Conflicts: netdata (<< ${source:Version})
Description: The python.d metrics collection plugin for the Netdata Agent
 Many of the collectors provided by this package are also available
 in netdata-plugin-god. In msot cases, you probably want to use those
 versions instead of the Python versions.

Package: netdata-plugin-go
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Suggests: nvme-cli, sudo
Conflicts: netdata (<< ${source:Version})
Description: The go.d metrics collection plugin for the Netdata Agent
 This plugin adds a selection of additional collectors written in Go to
 the Netdata Agent. A significant percentage of the application specific
 collectors provided by Netdata are part of this plugin, so most users
 will want it installed.

Package: netdata-plugin-apps
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The per-application metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect per-application and
 per-user metrics without using cgroups.

Package: netdata-plugin-slabinfo
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The slabinfo metrics collector for the Netdata Agent
 This plugin allows the Netdata Agent to collect perfromance and
 utilization metrics for the Linux kernel’s SLAB allocator.

Package: netdata-plugin-perf
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The perf metrics collector for the Netdata Agent
 This plugin allows the Netdata to collect metrics from the Linux perf
 subsystem.

Package: netdata-plugin-debugfs
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The debugfs metrics collector for the Netdata Agent
 This plugin allows the Netdata Agent to collect Linux kernel metrics
 exposed through debugfs.

Package: netdata-plugin-systemd-journal
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The systemd-journal collector for the Netdata Agent
 This plugin allows the Netdata Agent to present logs from the systemd
 journal on Netdata Cloud or the local Agent dashboard.

Package: netdata-plugin-xenstat
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: The xenstat plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the Xen
 Hypervisor.

Package: netdata-plugin-logs-management
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The logs-management plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect logs from the system
 and parse them to extract metrics.

Package: netdata-plugin-network-viewer
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Recommends: netdata-plugin-ebpf (= ${source:Version}) [amd64]
Conflicts: netdata (<< ${source:Version})
Description: The network viewer plugin for the Netdata Agent
 This plugin allows the Netdata Agent to provide network connection
 mapping functionality for use in netdata Cloud.

=== src/fluent-bit/lib/monkey/debian/control ===
Source: monkey
Section: httpd
Priority: optional
Maintainer: Eduardo Silva <eduardo@monkey.io>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libpolarssl-dev
Standards-Version: 3.9.1
Homepage: http://monkey-project.com
Vcs-Git: https://github.com/monkey/monkey.git
Vcs-Browser: https://github.com/monkey/monkey

Package: monkey
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast and lightweight Web Server for Linux.
 Monkey HTTP Server has been designed to be very scalable with low memory
 and CPU consumption, the perfect solution for embedded environments. It
 also provides a flexible API and plugins interface.

Package: monkey-polarssl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, monkey
Description: SSL transport layer for Monkey Web Server based in PolarSSL.
 This plugin enable Monkey Web Server with SSL encryption through the third
 party PolarSSL library.

Package: monkey-dev
Architecture: any
Depends: ${misc:Depends}, monkey (= ${binary:Version})
Description: Monkey HTTP Server development files
 This package distributes the C headers files required to perform
 the development of a Monkey plugin. This package is not related to the
 library version of Monkey.

Package: monkey-doc
Section: doc
Architecture: all
Description: Monkey documentation
 Monkey HTTP Server documentation.

=== contrib/debian/rules ===
#!/usr/bin/make -f

# Find the arch we are building for, as this determines
# the location of plugins in /usr/lib
SRC_DIR = /usr/src/netdata
TOP = $(CURDIR)/debian/netdata
TEMPTOP = $(CURDIR)/debian/tmp
BUILDDIR = $(CURDIR)/debian/build

BASE_CONFIG = system/netdata.conf

SYSTEMD_VERSION = $(shell /bin/sh -c "systemd --version 2>&1 | head -n 1 | cut -f 2 -d ' '")

ifeq ($(shell test $(SYSTEMD_VERSION) -gt 235 && echo "1"), 1)
SYSTEMD_UNIT = $(BUILDDIR)/system/systemd/netdata.service
else
SYSTEMD_UNIT = $(BUILDDIR)/system/systemd/netdata.service.v235
endif

ifeq ($(shell test ${DEB_TARGET_ARCH} != "amd64" && echo "1"), 1)
HAVE_EBPF = 0
EBPF_CONFIG = -DENABLE_PLUGIN_EBPF=Off
else
HAVE_EBPF = 1
EBPF_CONFIG = -DENABLE_PLUGIN_EBPF=On
endif

ifeq ($(shell test ${DEB_TARGET_ARCH} != "amd64" && echo "1"), 1)
ifeq ($(shell test ${DEB_TARGET_ARCH} != "arm64" && echo "1"), 1)
HAVE_XENSTAT = 0
XENSTAT_CONFIG = -DENABLE_PLUGIN_XENSTAT=Off
else
HAVE_XENSTAT = 1
XENSTAT_CONFIG = -DENABLE_PLUGIN_XENSTAT=On
endif
else
HAVE_XENSTAT = 1
XENSTAT_CONFIG = -DENABLE_PLUGIN_XENSTAT=On
endif

ifeq ($(ENABLE_SENTRY),true)
    RELEASE_PIPELINE ?= Unknown
    VERSION ?= Unknown
    BUILD_DESTINATION ?= Unknown
    SENTRY_CONFIG := -DENABLE_SENTRY=On \
        -DNETDATA_SENTRY_ENVIRONMENT=$(RELEASE_PIPELINE) \
        -DNETDATA_SENTRY_RELEASE=$(VERSION) \
        -DNETDATA_SENTRY_DIST=$(BUILD_DESTINATION) \
        -DNETDATA_SENTRY_DSN=$(SENTRY_DSN)
else
    SENTRY_CONFIG := -DENABLE_SENTRY=Off
endif


%:
	dh $@ --builddirectory=$(BUILDDIR)

override_dh_installinit:
	echo "SystemD Version: $(SYSTEMD_VERSION)"
	echo "Using SystemD Unit: $(SYSTEMD_UNIT)"
	cp -v $(SYSTEMD_UNIT) debian/netdata.service

	dh_systemd_enable
	dh_installinit

override_dh_auto_configure:
	if [ $(HAVE_EBPF) -eq 1 ]; then \
		packaging/bundle-libbpf.sh . ${TOP}/usr/libexec/netdata/plugins.d; \
		packaging/bundle-ebpf-co-re.sh . ${TOP}/usr/libexec/netdata/plugins.d; \
	fi
	dh_auto_configure -- -G Ninja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_PREFIX=/ \
		-DWEB_DIR=/var/lib/netdata/www \
		-DCMAKE_C_FLAGS='-ffile-prefix-map=${SRC_DIR}=${SRC_DIR}' \
		-DENABLE_ACLK=On \
		-DENABLE_CLOUD=On \
		-DENABLE_DBENGINE=On \
		-DENABLE_H2O=On \
		-DENABLE_ML=On \
		-DENABLE_PLUGIN_APPS=On \
		-DENABLE_PLUGIN_CGROUP_NETWORK=On \
		-DENABLE_PLUGIN_DEBUGFS=On \
		$(EBPF_CONFIG) \
		-DENABLE_PLUGIN_FREEIPMI=On \
		-DENABLE_PLUGIN_GO=On \
		-DENABLE_PLUGIN_LOCAL_LISTENERS=On \
		-DENABLE_PLUGIN_LOGS_MANAGEMENT=On \
		-DENABLE_PLUGIN_NFACCT=On \
		-DENABLE_PLUGIN_PERF=On \
		-DENABLE_PLUGIN_SLABINFO=On \
		-DENABLE_PLUGIN_SYSTEMD_JOURNAL=On \
		$(XENSTAT_CONFIG) \
		-DENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE=On \
		-DENABLE_EXPORTER_MONGODB=On \
		-DENABLE_BUNDLED_PROTOBUF=Off \
		-DENABLE_BUNDLED_JSONC=Off \
		${SENTRY_CONFIG} \
		-DENABLE_BUNDLED_YAML=Off

override_dh_auto_test:
	true

override_dh_strip:
	if [ "${ENABLE_SENTRY}" = "true" ] && [ "${UPLOAD_SENTRY}" = "true" ]; then \
		sentry-cli debug-files upload -o netdata-inc -p netdata-agent --force-foreground --log-level=debug --wait --include-sources /usr/src/netdata/debian/netdata/usr/sbin/netdata; \
	fi
	dh_strip

override_dh_install:
	cp -v $(BASE_CONFIG) debian/netdata.conf

	dh_install

	# Set the CUPS plugin install rule
	#
	mkdir -p $(TOP)-plugin-cups/usr/libexec/netdata/plugins.d
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/cups.plugin \
	$(TOP)-plugin-cups/usr/libexec/netdata/plugins.d/cups.plugin

	# Add free IPMI plugin install rules
	#
	mkdir -p $(TOP)-plugin-freeipmi/usr/libexec/netdata/plugins.d
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/freeipmi.plugin \
	$(TOP)-plugin-freeipmi/usr/libexec/netdata/plugins.d/freeipmi.plugin

	# Add NFACCT plugin install rules
	#
	mkdir -p $(TOP)-plugin-nfacct/usr/libexec/netdata/plugins.d
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/nfacct.plugin \
	$(TOP)-plugin-nfacct/usr/libexec/netdata/plugins.d/nfacct.plugin

	# Add charts.d plugin install rules
	#
	mkdir -p $(TOP)-plugin-chartsd/usr/libexec/netdata/plugins.d/
	mkdir -p $(TOP)-plugin-chartsd/usr/lib/netdata/conf.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/charts.d.plugin \
	$(TOP)-plugin-chartsd/usr/libexec/netdata/plugins.d/charts.d.plugin
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/charts.d.dryrun-helper.sh \
	$(TOP)-plugin-chartsd/usr/libexec/netdata/plugins.d/charts.d.dryrun-helper.sh
	mv -f $(TEMPTOP)/usr/libexec/netdata/charts.d \
	$(TOP)-plugin-chartsd/usr/libexec/netdata/charts.d
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/charts.d.conf \
	$(TOP)-plugin-chartsd/usr/lib/netdata/conf.d/charts.d.conf
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/charts.d \
	$(TOP)-plugin-chartsd/usr/lib/netdata/conf.d/charts.d

	# Add ebpf plugin install rules
	if [ $(HAVE_EBPF) -eq 1 ]; then \
		mkdir -p $(TOP)-plugin-ebpf/usr/libexec/netdata/plugins.d/; \
		mkdir -p $(TOP)-plugin-ebpf/usr/lib/netdata/conf.d/; \
		mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/ebpf.plugin $(TOP)-plugin-ebpf/usr/libexec/netdata/plugins.d/ebpf.plugin; \
		mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/ebpf.d.conf $(TOP)-plugin-ebpf/usr/lib/netdata/conf.d/ebpf.d.conf; \
		mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/ebpf.d $(TOP)-plugin-ebpf/usr/lib/netdata/conf.d/ebpf.d; \
	fi

	# Add python plugin install rules
	mkdir -p $(TOP)-plugin-pythond/usr/libexec/netdata/plugins.d/
	mkdir -p $(TOP)-plugin-pythond/usr/lib/netdata/conf.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/python.d.plugin \
	$(TOP)-plugin-pythond/usr/libexec/netdata/plugins.d/python.d.plugin
	mv -f $(TEMPTOP)/usr/libexec/netdata/python.d \
	$(TOP)-plugin-pythond/usr/libexec/netdata/python.d
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/python.d.conf \
	$(TOP)-plugin-pythond/usr/lib/netdata/conf.d/python.d.conf
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/python.d \
	$(TOP)-plugin-pythond/usr/lib/netdata/conf.d/python.d

	# Add apps plugin install rules
	mkdir -p $(TOP)-plugin-apps/usr/libexec/netdata/plugins.d/
	mkdir -p $(TOP)-plugin-apps/usr/lib/netdata/conf.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/apps.plugin \
	$(TOP)-plugin-apps/usr/libexec/netdata/plugins.d/apps.plugin
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/apps_groups.conf \
	$(TOP)-plugin-apps/usr/lib/netdata/conf.d/apps_groups.conf

	# Add slabinfo plugin install rules
	mkdir -p $(TOP)-plugin-slabinfo/usr/libexec/netdata/plugins.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/slabinfo.plugin \
	$(TOP)-plugin-slabinfo/usr/libexec/netdata/plugins.d/slabinfo.plugin

	# Add perf plugin install rules
	mkdir -p $(TOP)-plugin-perf/usr/libexec/netdata/plugins.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/perf.plugin \
	$(TOP)-plugin-perf/usr/libexec/netdata/plugins.d/perf.plugin

	# Add debugfs plugin install rules
	mkdir -p $(TOP)-plugin-debugfs/usr/libexec/netdata/plugins.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/debugfs.plugin \
	$(TOP)-plugin-debugfs/usr/libexec/netdata/plugins.d/debugfs.plugin

	# Add systemd-journal plugin install rules
	mkdir -p $(TOP)-plugin-systemd-journal/usr/libexec/netdata/plugins.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/systemd-journal.plugin \
	$(TOP)-plugin-systemd-journal/usr/libexec/netdata/plugins.d/systemd-journal.plugin

	# Add logs-management plugin install rules
	mkdir -p $(TOP)-plugin-logs-management/usr/libexec/netdata/plugins.d/
	mv -f $(TEMPTOP)/usr/libexec/netdata/plugins.d/logs-management.plugin \
	$(TOP)-plugin-logs-management/usr/libexec/netdata/plugins.d/logs-management.plugin
	mkdir -p $(TOP)-plugin-logs-management/usr/lib/netdata/conf.d/
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/logsmanagement.d.conf \
	$(TOP)-plugin-logs-management/usr/lib/netdata/conf.d/logsmanagement.d.conf
	mv -f $(TEMPTOP)/usr/lib/netdata/conf.d/logsmanagement.d/ \
	$(TOP)-plugin-logs-management/usr/lib/netdata/conf.d/logsmanagement.d/

	# Add xenstat plugin install rules
	if [ $(HAVE_XENSTAT) -eq 1 ]; then \
		mkdir -p $(TOP)-plugin-xenstat/usr/libexec/netdata/plugins.d/ ; \
